- Main Page
- Classes
- Files
- Directories
- Related Pages

- File List
- File Members

# ogr_api.h File Reference

`#include "ogr_core.h"`

Go to the source code of this file.

## Functions
OGRErr | OGR_G_CreateFromWkb (unsigned char *, OGRSpatialReferenceH, OGRGeometryH *, int)
OGRErr | OGR_G_CreateFromWkt (char **, OGRSpatialReferenceH, OGRGeometryH *)
void | OGR_G_DestroyGeometry (OGRGeometryH)
OGRGeometryH | OGR_G_CreateGeometry (OGRwkbGeometryType)
int | OGR_G_GetDimension (OGRGeometryH)
int | OGR_G_GetCoordinateDimension (OGRGeometryH)
OGRGeometryH | OGR_G_Clone (OGRGeometryH)
void | OGR_G_GetEnvelope (OGRGeometryH, OGREnvelope *)
OGRErr | OGR_G_ImportFromWkb (OGRGeometryH, unsigned char *, int)
OGRErr | OGR_G_ExportToWkb (OGRGeometryH, OGRwkbByteOrder, unsigned char *)
int | OGR_G_WkbSize (OGRGeometryH hGeom)
OGRErr | OGR_G_ImportFromWkt (OGRGeometryH, char **)
OGRErr | OGR_G_ExportToWkt (OGRGeometryH, char **)
OGRwkbGeometryType | OGR_G_GetGeometryType (OGRGeometryH)
const char * | OGR_G_GetGeometryName (OGRGeometryH)
void | OGR_G_DumpReadable (OGRGeometryH, FILE *, const char *)
void | OGR_G_FlattenTo2D (OGRGeometryH)
void | OGR_G_AssignSpatialReference (OGRGeometryH, OGRSpatialReferenceH)
OGRSpatialReferenceH | OGR_G_GetSpatialReference (OGRGeometryH)
OGRErr | OGR_G_Transform (OGRGeometryH, OGRCoordinateTransformationH)
OGRErr | OGR_G_TransformTo (OGRGeometryH, OGRSpatialReferenceH)
void | OGR_G_Segmentize (OGRGeometryH hGeom, double dfMaxLength)
int | OGR_G_Intersects (OGRGeometryH, OGRGeometryH)
int | OGR_G_Equals (OGRGeometryH, OGRGeometryH)
double | OGR_G_GetArea (OGRGeometryH)
void | OGR_G_Empty (OGRGeometryH)
int | OGR_G_IsEmpty (OGRGeometryH)
int | OGR_G_IsSimple (OGRGeometryH)
int | OGR_G_GetPointCount (OGRGeometryH)
double | OGR_G_GetX (OGRGeometryH, int)
double | OGR_G_GetY (OGRGeometryH, int)
double | OGR_G_GetZ (OGRGeometryH, int)
void | OGR_G_GetPoint (OGRGeometryH, int iPoint, double *, double *, double *)
void | OGR_G_SetPoint (OGRGeometryH, int iPoint, double, double, double)
void | OGR_G_SetPoint_2D (OGRGeometryH, int iPoint, double, double)
void | OGR_G_AddPoint (OGRGeometryH, double, double, double)
void | OGR_G_AddPoint_2D (OGRGeometryH, double, double)
int | OGR_G_GetGeometryCount (OGRGeometryH)
OGRGeometryH | OGR_G_GetGeometryRef (OGRGeometryH, int)
OGRErr | OGR_G_AddGeometry (OGRGeometryH, OGRGeometryH)
OGRErr | OGR_G_AddGeometryDirectly (OGRGeometryH, OGRGeometryH)
OGRErr | OGR_G_RemoveGeometry (OGRGeometryH, int, int)
OGRGeometryH | OGRBuildPolygonFromEdges (OGRGeometryH hLinesAsCollection, int bBestEffort, int bAutoClose, double dfTolerance, OGRErr *peErr)
OGRFieldDefnH | OGR_Fld_Create (const char *, OGRFieldType)
void | OGR_Fld_Destroy (OGRFieldDefnH)
void | OGR_Fld_SetName (OGRFieldDefnH, const char *)
const char * | OGR_Fld_GetNameRef (OGRFieldDefnH)
OGRFieldType | OGR_Fld_GetType (OGRFieldDefnH)
void | OGR_Fld_SetType (OGRFieldDefnH, OGRFieldType)
OGRJustification | OGR_Fld_GetJustify (OGRFieldDefnH)
void | OGR_Fld_SetJustify (OGRFieldDefnH, OGRJustification)
int | OGR_Fld_GetWidth (OGRFieldDefnH)
void | OGR_Fld_SetWidth (OGRFieldDefnH, int)
int | OGR_Fld_GetPrecision (OGRFieldDefnH)
void | OGR_Fld_SetPrecision (OGRFieldDefnH, int)
void | OGR_Fld_Set (OGRFieldDefnH, const char *, OGRFieldType, int, int, OGRJustification)
const char * | OGR_GetFieldTypeName (OGRFieldType)
OGRFeatureDefnH | OGR_FD_Create (const char *)
void | OGR_FD_Destroy (OGRFeatureDefnH)
void | OGR_FD_Release (OGRFeatureDefnH)
const char * | OGR_FD_GetName (OGRFeatureDefnH)
int | OGR_FD_GetFieldCount (OGRFeatureDefnH)
OGRFieldDefnH | OGR_FD_GetFieldDefn (OGRFeatureDefnH, int)
int | OGR_FD_GetFieldIndex (OGRFeatureDefnH, const char *)
void | OGR_FD_AddFieldDefn (OGRFeatureDefnH, OGRFieldDefnH)
OGRwkbGeometryType | OGR_FD_GetGeomType (OGRFeatureDefnH)
void | OGR_FD_SetGeomType (OGRFeatureDefnH, OGRwkbGeometryType)
int | OGR_FD_Reference (OGRFeatureDefnH)
int | OGR_FD_Dereference (OGRFeatureDefnH)
int | OGR_FD_GetReferenceCount (OGRFeatureDefnH)
OGRFeatureH | OGR_F_Create (OGRFeatureDefnH)
void | OGR_F_Destroy (OGRFeatureH)
OGRFeatureDefnH | OGR_F_GetDefnRef (OGRFeatureH)
OGRErr | OGR_F_SetGeometryDirectly (OGRFeatureH, OGRGeometryH)
OGRErr | OGR_F_SetGeometry (OGRFeatureH, OGRGeometryH)
OGRGeometryH | OGR_F_GetGeometryRef (OGRFeatureH)
OGRFeatureH | OGR_F_Clone (OGRFeatureH)
int | OGR_F_Equal (OGRFeatureH, OGRFeatureH)
int | OGR_F_GetFieldCount (OGRFeatureH)
OGRFieldDefnH | OGR_F_GetFieldDefnRef (OGRFeatureH, int)
int | OGR_F_GetFieldIndex (OGRFeatureH, const char *)
int | OGR_F_IsFieldSet (OGRFeatureH, int)
void | OGR_F_UnsetField (OGRFeatureH, int)
OGRField * | OGR_F_GetRawFieldRef (OGRFeatureH, int)
int | OGR_F_GetFieldAsInteger (OGRFeatureH, int)
double | OGR_F_GetFieldAsDouble (OGRFeatureH, int)
const char * | OGR_F_GetFieldAsString (OGRFeatureH, int)
const int * | OGR_F_GetFieldAsIntegerList (OGRFeatureH, int, int *)
const double * | OGR_F_GetFieldAsDoubleList (OGRFeatureH, int, int *)
char ** | OGR_F_GetFieldAsStringList (OGRFeatureH, int)
GByte * | OGR_F_GetFieldAsBinary (OGRFeatureH, int, int *)
int | OGR_F_GetFieldAsDateTime (OGRFeatureH, int, int *, int *, int *, int *, int *, int *, int *)
void | OGR_F_SetFieldInteger (OGRFeatureH, int, int)
void | OGR_F_SetFieldDouble (OGRFeatureH, int, double)
void | OGR_F_SetFieldString (OGRFeatureH, int, const char *)
void | OGR_F_SetFieldIntegerList (OGRFeatureH, int, int, int *)
void | OGR_F_SetFieldDoubleList (OGRFeatureH, int, int, double *)
void | OGR_F_SetFieldStringList (OGRFeatureH, int, char **)
void | OGR_F_SetFieldRaw (OGRFeatureH, int, OGRField *)
void | OGR_F_SetFieldBinary (OGRFeatureH, int, int, GByte *)
void | OGR_F_SetFieldDateTime (OGRFeatureH, int, int, int, int, int, int, int, int)
long | OGR_F_GetFID (OGRFeatureH)
OGRErr | OGR_F_SetFID (OGRFeatureH, long)
void | OGR_F_DumpReadable (OGRFeatureH, FILE *)
OGRErr | OGR_F_SetFrom (OGRFeatureH, OGRFeatureH, int)
const char * | OGR_F_GetStyleString (OGRFeatureH)
void | OGR_F_SetStyleString (OGRFeatureH, const char *)
void | OGR_F_SetStyleStringDirectly (OGRFeatureH, char *)
OGRGeometryH | OGR_L_GetSpatialFilter (OGRLayerH)
void | OGR_L_SetSpatialFilter (OGRLayerH, OGRGeometryH)
void | OGR_L_SetSpatialFilterRect (OGRLayerH, double, double, double, double)
OGRErr | OGR_L_SetAttributeFilter (OGRLayerH, const char *)
void | OGR_L_ResetReading (OGRLayerH)
OGRFeatureH | OGR_L_GetNextFeature (OGRLayerH)
OGRFeatureH | OGR_L_GetFeature (OGRLayerH, long)
OGRErr | OGR_L_SetFeature (OGRLayerH, OGRFeatureH)
OGRErr | OGR_L_CreateFeature (OGRLayerH, OGRFeatureH)
OGRErr | OGR_L_DeleteFeature (OGRLayerH, long)
OGRFeatureDefnH | OGR_L_GetLayerDefn (OGRLayerH)
OGRSpatialReferenceH | OGR_L_GetSpatialRef (OGRLayerH)
int | OGR_L_GetFeatureCount (OGRLayerH, int)
OGRErr | OGR_L_GetExtent (OGRLayerH, OGREnvelope *, int)
int | OGR_L_TestCapability (OGRLayerH, const char *)
OGRErr | OGR_L_CreateField (OGRLayerH, OGRFieldDefnH, int)
OGRErr | OGR_L_StartTransaction (OGRLayerH)
OGRErr | OGR_L_CommitTransaction (OGRLayerH)
OGRErr | OGR_L_RollbackTransaction (OGRLayerH)
void | OGR_DS_Destroy (OGRDataSourceH)
const char * | OGR_DS_GetName (OGRDataSourceH)
int | OGR_DS_GetLayerCount (OGRDataSourceH)
OGRLayerH | OGR_DS_GetLayer (OGRDataSourceH, int)
OGRLayerH | OGR_DS_GetLayerByName (OGRDataSourceH, const char *)
OGRLayerH | OGR_DS_CreateLayer (OGRDataSourceH, const char *, OGRSpatialReferenceH, OGRwkbGeometryType, char **)
int | OGR_DS_TestCapability (OGRDataSourceH, const char *)
OGRLayerH | OGR_DS_ExecuteSQL (OGRDataSourceH, const char *, OGRGeometryH, const char *)
void | OGR_DS_ReleaseResultSet (OGRDataSourceH, OGRLayerH)
const char * | OGR_Dr_GetName (OGRSFDriverH)
OGRDataSourceH | OGR_Dr_Open (OGRSFDriverH, const char *, int)
int | OGR_Dr_TestCapability (OGRSFDriverH, const char *)
OGRDataSourceH | OGR_Dr_CreateDataSource (OGRSFDriverH, const char *, char **)
OGRDataSourceH | OGROpen (const char *, int, OGRSFDriverH *)
void | OGRRegisterDriver (OGRSFDriverH)
int | OGRGetDriverCount (void)
OGRSFDriverH | OGRGetDriver (int)
void | OGRRegisterAll (void)
void | OGRCleanupAll (void)
OGRStyleMgrH | OGR_SM_Create (void *hStyleTable)
void | OGR_SM_Destroy (OGRStyleMgrH hSM)
const char * | OGR_SM_InitFromFeature (OGRStyleMgrH hSM, OGRFeatureH hFeat)
int | OGR_SM_InitStyleString (OGRStyleMgrH hSM, const char *pszStyleString)
int | OGR_SM_GetPartCount (OGRStyleMgrH hSM, const char *pszStyleString)
OGRStyleToolH | OGR_SM_GetPart (OGRStyleMgrH hSM, int nPartId, const char *pszStyleString)
int | OGR_SM_AddPart (OGRStyleMgrH hSM, OGRStyleToolH hST)
OGRStyleToolH | OGR_ST_Create (OGRSTClassId eClassId)
void | OGR_ST_Destroy (OGRStyleToolH hST)
OGRSTClassId | OGR_ST_GetType (OGRStyleToolH hST)
OGRSTUnitId | OGR_ST_GetUnit (OGRStyleToolH hST)
void | OGR_ST_SetUnit (OGRStyleToolH hST, OGRSTUnitId eUnit, double dfGroundPaperScale)
const char * | OGR_ST_GetParamStr (OGRStyleToolH hST, int eParam, int *bValueIsNull)
int | OGR_ST_GetParamNum (OGRStyleToolH hST, int eParam, int *bValueIsNull)
double | OGR_ST_GetParamDbl (OGRStyleToolH hST, int eParam, int *bValueIsNull)
void | OGR_ST_SetParamStr (OGRStyleToolH hST, int eParam, const char *pszValue)
void | OGR_ST_SetParamNum (OGRStyleToolH hST, int eParam, int nValue)
const char * | OGR_ST_GetStyleString (OGRStyleToolH hST)
int | OGR_ST_GetRGBFromString (OGRStyleToolH hST, const char *pszColor, int *pnRed, int *pnGreen, int *pnBlue, int *pnAlpha)

## Detailed Description

C API and defines for OGRFeature, OGRGeometry, and OGRDataSource related classes.

See also: ogr_geometry.h, ogr_feature.h, ogrsf_frmts.h, ogr_featurestyle.h

## Function Documentation

OGRDataSourceH OGR_Dr_CreateDataSource | ( | OGRSFDriverH | hDriver,
|  | const char * | pszName,
|  | char ** | papszOptions |
| ) |  |  |

This function attempts to create a new data source based on the passed driver. The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

This function is the same as the C++ method OGRSFDriver::CreateDataSource().

Parameters:

  | hDriver | handle to the driver on which data source creation is based.
  | pszName | the name for the new data source.
  | papszOptions | a StringList of name=value options. Options are driver specific, and driver information can be found at the following url: http://www.gdal.org/ogr/ogr_formats.html

Returns:
  NULL is returned on failure, or a new OGRDataSource handle on success.

const char * OGR_Dr_GetName | ( | OGRSFDriverH | hDriver | ) |

Fetch name of driver (file format). This name should be relatively short (10-40 characters), and should reflect the underlying file format. For instance "ESRI Shapefile".

This function is the same as the C++ method OGRSFDriver::GetName().

Parameters:

  | hDriver | handle to the the driver to get the name from.

Returns:
  driver name. This is an internal string and should not be modified or freed.

OGRDataSourceH OGR_Dr_Open | ( | OGRSFDriverH | hDriver,
|  | const char * | pszName,
|  | int | bUpdate |
| ) |  |  |

Attempt to open file with this driver.

This function is the same as the C++ method OGRSFDriver::Open().

Parameters:

  | hDriver | handle to the driver that is used to open file.
  | pszName | the name of the file, or data source to try and open.
  | bUpdate | TRUE if update access is required, otherwise FALSE (the default).

Returns:
  NULL on error or if the pass name is not supported by this driver, otherwise an handle to an OGRDataSource. This OGRDataSource should be closed by deleting the object when it is no longer needed.

int OGR_Dr_TestCapability | ( | OGRSFDriverH | hDriver,
|  | const char * | pszCap |
| ) |  |  |

Test if capability is available.

One of the following data source capability names can be passed into this function, and a TRUE or FALSE value will be returned indicating whether or not the capability is available for this object.

- ODrCCreateDataSource: True if this driver can support creating data sources.

- ODrCDeleteDataSource: True if this driver supports deleting data sources.

The #define macro forms of the capability names should be used in preference to the strings themselves to avoid mispelling.

This function is the same as the C++ method OGRSFDriver::TestCapability().

Parameters:

  | hDriver | handle to the driver to test the capability against.
  | pszCap | the capability to test.

Returns:
  TRUE if capability available otherwise FALSE.

OGRLayerH OGR_DS_CreateLayer | ( | OGRDataSourceH | hDS,
|  | const char * | pszName,
|  | OGRSpatialReferenceH | hSpatialRef,
|  | OGRwkbGeometryType | eType,
|  | char ** | papszOptions |
| ) |  |  |

This function attempts to create a new layer on the data source with the indicated name, coordinate system, geometry type. The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

This function is the same as the C++ method OGRDataSource::CreateLayer().

Parameters:

  | hDS | The dataset handle.
  | pszName | the name for the new layer. This should ideally not match any existing layer on the datasource.
  | hSpatialRef | handle to the coordinate system to use for the new layer, or NULL if no coordinate system is available.
  | eType | the geometry type for the layer. Use wkbUnknown if there are no constraints on the types geometry to be written.
  | papszOptions | a StringList of name=value options. Options are driver specific, and driver information can be found at the following url: http://www.gdal.org/ogr/ogr_formats.html

Returns:
  NULL is returned on failure, or a new OGRLayer handle on success.

Example:

    #include "ogrsf_frmts.h"
    #include "cpl_string.h"

    ...

            OGRLayerH *hLayer;
            char     *papszOptions;

            if( OGR_DS_TestCapability( hDS, ODsCCreateLayer ) )
            {
                ...
            }

            papszOptions = CSLSetNameValue( papszOptions, "DIM", "2" );
            hLayer = OGR_DS_CreateLayer( hDS, "NewLayer", NULL, wkbUnknown,
                                         papszOptions );
            CSLDestroy( papszOptions );

            if( hLayer == NULL )
            {
                ...
            }

void OGR_DS_Destroy | ( | OGRDataSourceH | hDataSource | ) |

Closes opened datasource and releases allocated resources.

Parameters:

  | hDataSource | handle to allocated datasource object.

OGRLayerH OGR_DS_ExecuteSQL | ( | OGRDataSourceH | hDS,
|  | const char * | pszSQLCommand,
|  | OGRGeometryH | hSpatialFilter,
|  | const char * | pszDialect |
| ) |  |  |

Execute an SQL statement against the data store.

The result of an SQL query is either NULL for statements that are in error, or that have no results set, or an OGRLayer handle representing a results set from the query. Note that this OGRLayer is in addition to the layers in the data store and must be destroyed with OGR_DS_ReleaseResultsSet() before the data source is closed (destroyed).

For more information on the SQL dialect supported internally by OGR review the OGR SQL document. Some drivers (ie. Oracle and PostGIS) pass the SQL directly through to the underlying RDBMS.

This function is the same as the C++ method OGRDataSource::ExecuteSQL();

Parameters:

  | hDS | handle to the data source on which the SQL query is executed.
  | pszSQLCommand | the SQL statement to execute.
  | hSpatialFilter | handle to a geometry which represents a spatial filter.
  | pszDialect | allows control of the statement dialect. By default it is assumed to be "generic" SQL, whatever that is.

Returns:
  an handle to a OGRLayer containing the results of the query. Deallocate with OGR_DS_ReleaseResultsSet().

OGRLayerH OGR_DS_GetLayer | ( | OGRDataSourceH | hDS,
|  | int | iLayer |
| ) |  |  |

Fetch a layer by index. The returned layer remains owned by the OGRDataSource and should not be deleted by the application.

This function is the same as the C++ method OGRDataSource::GetLayer().

Parameters:

  | hDS | handle to the data source from which to get the layer.
  | iLayer | a layer number between 0 and OGR_DS_GetLayerCount()-1.

Returns:
  an handle to the layer, or NULL if iLayer is out of range or an error occurs.

OGRLayerH OGR_DS_GetLayerByName | ( | OGRDataSourceH | hDS,
|  | const char * | pszLayerName |
| ) |  |  |

Fetch a layer by name. The returned layer remains owned by the OGRDataSource and should not be deleted by the application.

This function is the same as the C++ method OGRDataSource::GetLayerByName().

Parameters:

  | hDS | handle to the data source from which to get the layer.
  | pszLayerName | Layer the layer name of the layer to fetch.

Returns:
  an handle to the layer, or NULL if the layer is not found or an error occurs.

int OGR_DS_GetLayerCount | ( | OGRDataSourceH | hDS | ) |

Get the number of layers in this data source.

This function is the same as the C++ method OGRDataSource::GetLayerCount().

Parameters:

  | hDS | handle to the data source from which to get the number of layers.

Returns:
  layer count.

const char * OGR_DS_GetName | ( | OGRDataSourceH | hDS | ) |

Returns the name of the data source. This string should be sufficient to open the data source if passed to the same OGRSFDriver that this data source was opened with, but it need not be exactly the same string that was used to open the data source. Normally this is a filename.

This function is the same as the C++ method OGRDataSource::GetName().

Parameters:

  | hDS | handle to the data source to get the name from.

Returns:
  pointer to an internal name string which should not be modified or freed by the caller.

void OGR_DS_ReleaseResultSet | ( | OGRDataSourceH | hDS,
|  | OGRLayerH | hLayer |
| ) |  |  |

Release results of OGR_DS_ExecuteSQL().

This function should only be used to deallocate OGRLayers resulting from an OGR_DS_ExecuteSQL() call on the same OGRDataSource. Failure to deallocate a results set before destroying the OGRDataSource may cause errors.

This function is the same as the C++ method OGRDataSource::ReleaseResultsSet().

Parameters:

  | hDS | an handle to the data source on which was executed an SQL query.
  | hLayer | handle to the result of a previous OGR_DS_ExecuteSQL() call.

int OGR_DS_TestCapability | ( | OGRDataSourceH | hDS,
|  | const char * | pszCapability |
| ) |  |  |

Test if capability is available.

One of the following data source capability names can be passed into this function, and a TRUE or FALSE value will be returned indicating whether or not the capability is available for this object.

- ODsCCreateLayer: True if this datasource can create new layers.

The #define macro forms of the capability names should be used in preference to the strings themselves to avoid mispelling.

This function is the same as the C++ method OGRDataSource::TestCapability().

Parameters:

  | hDS | handle to the data source against which to test the capability.
  | pszCapability | the capability to test.

Returns:
  TRUE if capability available otherwise FALSE.

OGRFeatureH OGR_F_Clone | ( | OGRFeatureH | hFeat | ) |

Duplicate feature.

The newly created feature is owned by the caller, and will have it's own reference to the OGRFeatureDefn.

This function is the same as the C++ method OGRFeature::Clone().

Parameters:

  | hFeat | handle to the feature to clone.

Returns:
  an handle to the new feature, exactly matching this feature.

OGRFeatureH OGR_F_Create | ( | OGRFeatureDefnH | hDefn | ) |

Feature factory.

Note that the OGRFeature will increment the reference count of it's defining OGRFeatureDefn. Destruction of the OGRFeatureDefn before destruction of all OGRFeatures that depend on it is likely to result in a crash.

This function is the same as the C++ method OGRFeature::OGRFeature().

Parameters:

  | hDefn | handle to the feature class (layer) definition to which the feature will adhere.

Returns:
  an handle to the new feature object with null fields and no geometry.

void OGR_F_Destroy | ( | OGRFeatureH | hFeat | ) |

Destroy feature

The feature is deleted, but within the context of the GDAL/OGR heap. This is necessary when higher level applications use GDAL/OGR from a DLL and they want to delete a feature created within the DLL. If the delete is done in the calling application the memory will be freed onto the application heap which is inappropriate.

This function is the same as the C++ method OGRFeature::DestroyFeature().

Parameters:

  | hFeat | handle to the feature to destroy.

void OGR_F_DumpReadable | ( | OGRFeatureH | hFeat,
|  | FILE * | fpOut |
| ) |  |  |

Dump this feature in a human readable form.

This dumps the attributes, and geometry; however, it doesn't definition information (other than field types and names), nor does it report the geometry spatial reference system.

This function is the same as the C++ method OGRFeature::DumpReadable().

Parameters:

  | hFeat | handle to the feature to dump.
  | fpOut | the stream to write to, such as strout.

int OGR_F_Equal | ( | OGRFeatureH | hFeat,
|  | OGRFeatureH | hOtherFeat |
| ) |  |  |

Test if two features are the same.

Two features are considered equal if the share them (handle equality) same OGRFeatureDefn, have the same field values, and the same geometry (as tested by OGR_G_Equal()) as well as the same feature id.

This function is the same as the C++ method OGRFeature::Equal().

Parameters:

  | hFeat | handle to one of the feature.
  | hOtherFeat | handle to the other feature to test this one against.

Returns:
  TRUE if they are equal, otherwise FALSE.

OGRFeatureDefnH OGR_F_GetDefnRef | ( | OGRFeatureH | hFeat | ) |

Fetch feature definition.

This function is the same as the C++ method OGRFeature::GetDefnRef().

Parameters:

  | hFeat | handle to the feature to get the feature definition from.

Returns:
  an handle to the feature definition object on which feature depends.

long OGR_F_GetFID | ( | OGRFeatureH | hFeat | ) |

Get feature identifier.

This function is the same as the C++ method OGRFeature::GetFID().

Parameters:

  | hFeat | handle to the feature from which to get the feature identifier.

Returns:
  feature id or OGRNullFID if none has been assigned.

GByte* OGR_F_GetFieldAsBinary | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnBytes |
| ) |  |  |

Fetch field value as binary.

Currently this method only works for OFTBinary fields.

This function is the same as the C++ method OGRFeature::GetFieldAsBinary().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pnBytes | location to place count of bytes returned.

Returns:
  the field value. This list is internal, and should not be modified, or freed. It's lifetime may be very brief.

int OGR_F_GetFieldAsDateTime | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnYear,
|  | int * | pnMonth,
|  | int * | pnDay,
|  | int * | pnHour,
|  | int * | pnMinute,
|  | int * | pnSecond,
|  | int * | pnTZFlag |
| ) |  |  |

Fetch field value as date and time.

Currently this method only works for OFTDate, OFTTime and OFTDateTime fields.

This function is the same as the C++ method OGRFeature::GetFieldAsDateTime().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | int | pnYear (including century)
  | int | pnMonth (1-12)
  | int | pnDay (1-31)
  | int | pnHour (0-23)
  | int | pnMinute (0-59)
  | int | pnSecond (0-59)
  | int | pnTZFlag (0=unknown, 1=localtime, 100=GMT, see data model for details)

Returns:
  TRUE on success or FALSE on failure.

double OGR_F_GetFieldAsDouble | ( | OGRFeatureH | hFeat,
|  | int | iField |
| ) |  |  |

Fetch field value as a double.

OFTString features will be translated using atof(). OFTInteger fields will be cast to double. Other field types, or errors will result in a return value of zero.

This function is the same as the C++ method OGRFeature::GetFieldAsDouble().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns:
  the field value.

const double* OGR_F_GetFieldAsDoubleList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnCount |
| ) |  |  |

Fetch field value as a list of doubles.

Currently this function only works for OFTRealList fields.

This function is the same as the C++ method OGRFeature::GetFieldAsDoubleList().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pnCount | an integer to put the list count (number of doubles) into.

Returns:
  the field value. This list is internal, and should not be modified, or freed. It's lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

int OGR_F_GetFieldAsInteger | ( | OGRFeatureH | hFeat,
|  | int | iField |
| ) |  |  |

Fetch field value as integer.

OFTString features will be translated using atoi(). OFTReal fields will be cast to integer. Other field types, or errors will result in a return value of zero.

This function is the same as the C++ method OGRFeature::GetFieldAsInteger().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns:
  the field value.

const int* OGR_F_GetFieldAsIntegerList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnCount |
| ) |  |  |

Fetch field value as a list of integers.

Currently this function only works for OFTIntegerList fields.

This function is the same as the C++ method OGRFeature::GetFieldAsIntegerList().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pnCount | an integer to put the list count (number of integers) into.

Returns:
  the field value. This list is internal, and should not be modified, or freed. It's lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

const char* OGR_F_GetFieldAsString | ( | OGRFeatureH | hFeat,
|  | int | iField |
| ) |  |  |

Fetch field value as a string.

OFTReal and OFTInteger fields will be translated to string using sprintf(), but not necessarily using the established formatting rules. Other field types, or errors will result in a return value of zero.

This function is the same as the C++ method OGRFeature::GetFieldAsString().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns:
  the field value. This string is internal, and should not be modified, or freed. It's lifetime may be very brief.

char** OGR_F_GetFieldAsStringList | ( | OGRFeatureH | hFeat,
|  | int | iField |
| ) |  |  |

Fetch field value as a list of strings.

Currently this method only works for OFTStringList fields.

The returned list is terminated by a NULL pointer. The number of elements can also be calculated using CSLCount().

This function is the same as the C++ method OGRFeature::GetFieldAsStringList().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns:
  the field value. This list is internal, and should not be modified, or freed. It's lifetime may be very brief.

int OGR_F_GetFieldCount | ( | OGRFeatureH | hFeat | ) |

Fetch number of fields on this feature. This will always be the same as the field count for the OGRFeatureDefn.

This function is the same as the C++ method OGRFeature::GetFieldCount().

Parameters:

  | hFeat | handle to the feature to get the fields count from.

Returns:
  count of fields.

OGRFieldDefnH OGR_F_GetFieldDefnRef | ( | OGRFeatureH | hFeat,
|  | int | i |
| ) |  |  |

Fetch definition for this field.

This function is the same as the C++ method OGRFeature::GetFieldDefnRef().

Parameters:

  | hFeat | handle to the feature on which the field is found.
  | i | the field to fetch, from 0 to GetFieldCount()-1.

Returns:
  an handle to the field definition (from the OGRFeatureDefn). This is an internal reference, and should not be deleted or modified.

int OGR_F_GetFieldIndex | ( | OGRFeatureH | hFeat,
|  | const char * | pszName |
| ) |  |  |

Fetch the field index given field name.

This is a cover for the OGRFeatureDefn::GetFieldIndex() method.

This function is the same as the C++ method OGRFeature::GetFieldIndex().

Parameters:

  | hFeat | handle to the feature on which the field is found.
  | pszName | the name of the field to search for.

Returns:
  the field index, or -1 if no matching field is found.

OGRGeometryH OGR_F_GetGeometryRef | ( | OGRFeatureH | hFeat | ) |

Fetch an handle to feature geometry.

This function is the same as the C++ method OGRFeature::GetGeometryRef().

Parameters:

  | hFeat | handle to the feature to get geometry from.

Returns:
  an handle to internal feature geometry. This object should not be modified.

OGRField* OGR_F_GetRawFieldRef | ( | OGRFeatureH | hFeat,
|  | int | iField |
| ) |  |  |

Fetch an handle to the internal field value given the index.

This function is the same as the C++ method OGRFeature::GetRawFieldRef().

Parameters:

  | hFeat | handle to the feature on which field is found.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns:
  the returned handle is to an internal data structure, and should not be freed, or modified.

const char* OGR_F_GetStyleString | ( | OGRFeatureH | hFeat | ) |

Fetch style string for this feature.

Set the OGR Feature Style Specification for details on the format of this string, and ogr_featurestyle.h for services available to parse it.

This function is the same as the C++ method OGRFeature::GetStyleString().

Parameters:

  | hFeat | handle to the feature to get the style from.

Returns:
  a reference to a representation in string format, or NULL if there isn't one.

int OGR_F_IsFieldSet | ( | OGRFeatureH | hFeat,
|  | int | iField |
| ) |  |  |

Test if a field has ever been assigned a value or not.

This function is the same as the C++ method OGRFeature::IsFieldSet().

Parameters:

  | hFeat | handle to the feature on which the field is.
  | iField | the field to test.

Returns:
  TRUE if the field has been set, otherwise false.

OGRErr OGR_F_SetFID | ( | OGRFeatureH | hFeat,
|  | long | nFID |
| ) |  |  |

Set the feature identifier.

For specific types of features this operation may fail on illegal features ids. Generally it always succeeds. Feature ids should be greater than or equal to zero, with the exception of OGRNullFID (-1) indicating that the feature id is unknown.

This function is the same as the C++ method OGRFeature::SetFID().

Parameters:

  | hFeat | handle to the feature to set the feature id to.
  | nFID | the new feature identifier value to assign.

Returns:
  On success OGRERR_NONE, or on failure some other value.

void OGR_F_SetFieldBinary | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nBytes,
|  | GByte * | pabyData |
| ) |  |  |

Set field to binary data.

This function currently on has an effect of OFTBinary fields.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nBytes | the number of bytes in pabyData array.
  | pabyData | the data to apply.

void OGR_F_SetFieldDateTime | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nYear,
|  | int | nMonth,
|  | int | nDay,
|  | int | nHour,
|  | int | nMinute,
|  | int | nSecond,
|  | int | nTZFlag |
| ) |  |  |

Set field to datetime.

This method currently only has an effect for OFTDate, OFTTime and OFTDateTime fields.

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nYear | (including century)
  | nMonth | (1-12)
  | nDay | (1-31)
  | nHour | (0-23)
  | nMinute | (0-59)
  | nSecond | (0-59)
  | nTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

void OGR_F_SetFieldDouble | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | double | dfValue |
| ) |  |  |

Set field to double value.

OFTInteger and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | dfValue | the value to assign.

void OGR_F_SetFieldDoubleList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nCount,
|  | double * | padfValues |
| ) |  |  |

Set field to list of doubles value.

This function currently on has an effect of OFTRealList fields.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nCount | the number of values in the list being assigned.
  | padfValues | the values to assign.

void OGR_F_SetFieldInteger | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nValue |
| ) |  |  |

Set field to integer value.

OFTInteger and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | nValue | the value to assign.

void OGR_F_SetFieldIntegerList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nCount,
|  | int * | panValues |
| ) |  |  |

Set field to list of integers value.

This function currently on has an effect of OFTIntegerList fields.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | nCount | the number of values in the list being assigned.
  | panValues | the values to assign.

void OGR_F_SetFieldRaw | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | OGRField * | psValue |
| ) |  |  |

Set field.

The passed value OGRField must be of exactly the same type as the target field, or an application crash may occur. The passed value is copied, and will not be affected. It remains the responsibility of the caller.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | psValue | handle on the value to assign.

void OGR_F_SetFieldString | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | const char * | pszValue |
| ) |  |  |

Set field to string value.

OFTInteger fields will be set based on an atoi() conversion of the string. OFTReal fields will be set based on an atof() conversion of the string. Other field types may be unaffected.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to fetch, from 0 to GetFieldCount()-1.
  | pszValue | the value to assign.

void OGR_F_SetFieldStringList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | char ** | papszValues |
| ) |  |  |

Set field to list of strings value.

This function currently on has an effect of OFTStringList fields.

This function is the same as the C++ method OGRFeature::SetField().

Parameters:

  | hFeat | handle to the feature that owned the field.
  | iField | the field to set, from 0 to GetFieldCount()-1.
  | papszValues | the values to assign.

OGRErr OGR_F_SetFrom | ( | OGRFeatureH | hFeat,
|  | OGRFeatureH | hOtherFeat,
|  | int | bForgiving |
| ) |  |  |

Set one feature from another.

Overwrite the contents of this feature from the geometry and attributes of another. The hOtherFeature does not need to have the same OGRFeatureDefn. Field values are copied by corresponding field names. Field types do not have to exactly match. OGR_F_SetField*() function conversion rules will be applied as needed.

This function is the same as the C++ method OGRFeature::SetFrom().

Parameters:

  | hFeat | handle to the feature to set to.
  | hOtherFeat | handle to the feature from which geometry, and field values will be copied.
  | bForgiving | TRUE if the operation should continue despite lacking output fields matching some of the source fields.

Returns:
  OGRERR_NONE if the operation succeeds, even if some values are not transferred, otherwise an error code.

OGRErr OGR_F_SetGeometry | ( | OGRFeatureH | hFeat,
|  | OGRGeometryH | hGeom |
| ) |  |  |

Set feature geometry.

This function updates the features geometry, and operate exactly as SetGeometryDirectly(), except that this function does not assume ownership of the passed geometry, but instead makes a copy of it.

This function is the same as the C++ OGRFeature::SetGeometry().

Parameters:

  | hFeat | handle to the feature on which new geometry is applied to.
  | hGeom | handle to the new geometry to apply to feature.

Returns:
  OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

OGRErr OGR_F_SetGeometryDirectly | ( | OGRFeatureH | hFeat,
|  | OGRGeometryH | hGeom |
| ) |  |  |

Set feature geometry.

This function updates the features geometry, and operate exactly as SetGeometry(), except that this function assumes ownership of the passed geometry.

This function is the same as the C++ method OGRFeature::SetGeometryDirectly.

Parameters:

  | hFeat | handle to the feature on which to apply the geometry.
  | hGeom | handle to the new geometry to apply to feature.

Returns:
  OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

void OGR_F_SetStyleString | ( | OGRFeatureH | hFeat,
|  | const char * | pszStyle |
| ) |  |  |

Set feature style string. This method operate exactly as OGR_F_SetStyleStringDirectly() except that it does not assume ownership of the passed string, but instead makes a copy of it.

This function is the same as the C++ method OGRFeature::SetStyleString().

Parameters:

  | hFeat | handle to the feature to set style to.
  | pszStyle | the style string to apply to this feature, cannot be NULL.

void OGR_F_SetStyleStringDirectly | ( | OGRFeatureH | hFeat,
|  | char * | pszStyle |
| ) |  |  |

Set feature style string. This method operate exactly as OGR_F_SetStyleString() except that it assumes ownership of the passed string.

This function is the same as the C++ method OGRFeature::SetStyleStringDirectly().

Parameters:

  | hFeat | handle to the feature to set style to.
  | pszStyle | the style string to apply to this feature, cannot be NULL.

void OGR_F_UnsetField | ( | OGRFeatureH | hFeat,
|  | int | iField |
| ) |  |  |

Clear a field, marking it as unset.

This function is the same as the C++ method OGRFeature::UnsetField().

Parameters:

  | hFeat | handle to the feature on which the field is.
  | iField | the field to unset.

void OGR_FD_AddFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | OGRFieldDefnH | hNewField |
| ) |  |  |

Add a new field definition to the passed feature definition.

This function should only be called while there are no OGRFeature objects in existance based on this OGRFeatureDefn. The OGRFieldDefn passed in is copied, and remains the responsibility of the caller.

This function is the same as the C++ method OGRFeatureDefn::AddFieldDefn.

Parameters:

  | hDefn | handle to the feature definition to add the field definition to.
  | hNewField | handle to the new field definition.

OGRFeatureDefnH OGR_FD_Create | ( | const char * | pszName | ) |

Create a new feature definition object to held the field definitions.

The OGRFeatureDefn maintains a reference count, but this starts at zero, and should normally be incremented by the owner.

This function is the same as the C++ method OGRFeatureDefn::OGRFeatureDefn().

Parameters:

  | pszName | the name to be assigned to this layer/class. It does not need to be unique.

Returns:
  handle to the newly created feature definition.

int OGR_FD_Dereference | ( | OGRFeatureDefnH | hDefn | ) |

Decrements the reference count by one.

This function is the same as the C++ method OGRFeatureDefn::Dereference().

Parameters:

  | hDefn | handle to the feature definition on witch OGRFeature are based on.

Returns:
  the updated reference count.

void OGR_FD_Destroy | ( | OGRFeatureDefnH | hDefn | ) |

Destroy a feature definition object and release all memory associated with it.

This function is the same as the C++ method OGRFeatureDefn::~OGRFeatureDefn().

Parameters:

  | hDefn | handle to the feature definition to be destroyed.

int OGR_FD_GetFieldCount | ( | OGRFeatureDefnH | hDefn | ) |

Fetch number of fields on the passed feature definition.

This function is the same as the C++ OGRFeatureDefn::GetFieldCount().

Parameters:

  | hDefn | handle to the feature definition to get the fields count from.

Returns:
  count of fields.

OGRFieldDefnH OGR_FD_GetFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | int | iField |
| ) |  |  |

Fetch field definition of the passed feature definition.

This function is the same as the C++ method OGRFeatureDefn::GetFieldDefn().

Parameters:

  | hDefn | handle to the feature definition to get the field definition from.
  | iField | the field to fetch, between 0 and GetFieldCount()-1.

Returns:
  an handle to an internal field definition object. This object should not be modified or freed by the application.

int OGR_FD_GetFieldIndex | ( | OGRFeatureDefnH | hDefn,
|  | const char * | pszFieldName |
| ) |  |  |

Find field by name.

The field index of the first field matching the passed field name (case insensitively) is returned.

This function is the same as the C++ method OGRFeatureDefn::GetFieldIndex.

Parameters:

  | hDefn | handle to the feature definition to get field index from.
  | pszFieldName | the field name to search for.

Returns:
  the field index, or -1 if no match found.

OGRwkbGeometryType OGR_FD_GetGeomType | ( | OGRFeatureDefnH | hDefn | ) |

Fetch the geometry base type of the passed feature definition.

This function is the same as the C++ method OGRFeatureDefn::GetGeomType().

Parameters:

  | hDefn | handle to the feature definition to get the geometry type from.

Returns:
  the base type for all geometry related to this definition.

const char* OGR_FD_GetName | ( | OGRFeatureDefnH | hDefn | ) |

Get name of the OGRFeatureDefn passed as an argument.

This function is the same as the C++ method OGRFeatureDefn::GetName().

Parameters:

  | hDefn | handle to the feature definition to get the name from.

Returns:
  the name. This name is internal and should not be modified, or freed.

int OGR_FD_GetReferenceCount | ( | OGRFeatureDefnH | hDefn | ) |

Fetch current reference count.

This function is the same as the C++ method OGRFeatureDefn::GetReferenceCount().

Parameters:

  | hDefn | hanlde to the feature definition on witch OGRFeature are based on.

Returns:
  the current reference count.

int OGR_FD_Reference | ( | OGRFeatureDefnH | hDefn | ) |

Increments the reference count by one.

The reference count is used keep track of the number of OGRFeature objects referencing this definition.

This function is the same as the C++ method OGRFeatureDefn::Reference().

Parameters:

  | hDefn | handle to the feature definition on witch OGRFeature are based on.

Returns:
  the updated reference count.

void OGR_FD_Release | ( | OGRFeatureDefnH | hDefn | ) |

Drop a reference, and destroy if unreferenced.

This function is the same as the C++ method OGRFeatureDefn::Release().

Parameters:

  | hDefn | handle to the feature definition to be released.

void OGR_FD_SetGeomType | ( | OGRFeatureDefnH | hDefn,
|  | OGRwkbGeometryType | eType |
| ) |  |  |

Assign the base geometry type for the passed layer (the same as the feature definition).

All geometry objects using this type must be of the defined type or a derived type. The default upon creation is wkbUnknown which allows for any geometry type. The geometry type should generally not be changed after any OGRFeatures have been created against this definition.

This function is the same as the C++ method OGRFeatureDefn::SetGeomType().

Parameters:

  | hDefn | handle to the layer or feature definition to set the geometry type to.
  | eType | the new type to assign.

OGRFieldDefnH OGR_Fld_Create | ( | const char * | pszName,
|  | OGRFieldType | eType |
| ) |  |  |

Create a new field definition.

This function is the same as the CPP method OGRFieldDefn::OGRFieldDefn().

Parameters:

  | pszName | the name of the new field definition.
  | eType | the type of the new field definition.

Returns:
  handle to the new field definition.

void OGR_Fld_Destroy | ( | OGRFieldDefnH | hDefn | ) |

Destroy a field definition.

Parameters:

  | hDefn | handle to the field definition to destroy.

OGRJustification OGR_Fld_GetJustify | ( | OGRFieldDefnH | hDefn | ) |

Get the justification for this field.

This function is the same as the CPP method OGRFieldDefn::GetJustify().

Parameters:

  | hDefn | handle to the field definition to get justification from.

Returns:
  the justification.

const char* OGR_Fld_GetNameRef | ( | OGRFieldDefnH | hDefn | ) |

Fetch name of this field.

This function is the same as the CPP method OGRFieldDefn::GetNameRef().

Parameters:

  | hDefn | handle to the field definition.

Returns:
  the name of the field definition.

int OGR_Fld_GetPrecision | ( | OGRFieldDefnH | hDefn | ) |

Get the formatting precision for this field. This should normally be zero for fields of types other than OFTReal.

This function is the same as the CPP method OGRFieldDefn::GetPrecision().

Parameters:

  | hDefn | handle to the field definition to get precision from.

Returns:
  the precision.

OGRFieldType OGR_Fld_GetType | ( | OGRFieldDefnH | hDefn | ) |

Fetch type of this field.

This function is the same as the CPP method OGRFieldDefn::GetType().

Parameters:

  | hDefn | handle to the field definition to get type from.

Returns:
  field type.

int OGR_Fld_GetWidth | ( | OGRFieldDefnH | hDefn | ) |

Get the formatting width for this field.

This function is the same as the CPP method OGRFieldDefn::GetWidth().

Parameters:

  | hDefn | handle to the field definition to get width from.

Returns:
  the width, zero means no specified width.

void OGR_Fld_Set | ( | OGRFieldDefnH | hDefn,
|  | const char * | pszNameIn,
|  | OGRFieldType | eTypeIn,
|  | int | nWidthIn,
|  | int | nPrecisionIn,
|  | OGRJustification | eJustifyIn |
| ) |  |  |

Set defining parameters for a field in one call.

This function is the same as the CPP method OGRFieldDefn::Set().

Parameters:

  | hDefn | handle to the field definition to set to.
  | pszNameIn | the new name to assign.
  | eTypeIn | the new type (one of the OFT values like OFTInteger).
  | nWidthIn | the preferred formatting width. Defaults to zero indicating undefined.
  | nPrecisionIn | number of decimals places for formatting, defaults to zero indicating undefined.
  | eJustifyIn | the formatting justification (OJLeft or OJRight), defaults to OJUndefined.

void OGR_Fld_SetJustify | ( | OGRFieldDefnH | hDefn,
|  | OGRJustification | eJustify |
| ) |  |  |

Set the justification for this field.

This function is the same as the CPP method OGRFieldDefn::SetJustify().

Parameters:

  | hDefn | handle to the field definition to set justification to.
  | eJustify | the new justification.

void OGR_Fld_SetName | ( | OGRFieldDefnH | hDefn,
|  | const char * | pszName |
| ) |  |  |

Reset the name of this field.

This function is the same as the CPP method OGRFieldDefn::SetName().

Parameters:

  | hDefn | handle to the field definition to apply the new name to.
  | pszName | the new name to apply.

void OGR_Fld_SetPrecision | ( | OGRFieldDefnH | hDefn,
|  | int | nPrecision |
| ) |  |  |

Set the formatting precision for this field in characters.

This should normally be zero for fields of types other than OFTReal.

This function is the same as the CPP method OGRFieldDefn::SetPrecision().

Parameters:

  | hDefn | handle to the field definition to set precision to.
  | nPrecision | the new precision.

void OGR_Fld_SetType | ( | OGRFieldDefnH | hDefn,
|  | OGRFieldType | eType |
| ) |  |  |

Set the type of this field. This should never be done to an OGRFieldDefn that is already part of an OGRFeatureDefn.

This function is the same as the CPP method OGRFieldDefn::SetType().

Parameters:

  | hDefn | handle to the field definition to set type to.
  | eType | the new field type.

void OGR_Fld_SetWidth | ( | OGRFieldDefnH | hDefn,
|  | int | nNewWidth |
| ) |  |  |

Set the formatting width for this field in characters.

This function is the same as the CPP method OGRFieldDefn::SetWidth().

Parameters:

  | hDefn | handle to the field definition to set width to.
  | nNewWidth | the new width.

OGRErr OGR_G_AddGeometry | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hNewSubGeom |
| ) |  |  |

Add a geometry to a geometry container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. The passed geometry is cloned to make an internal copy.

There is no SFCOM analog to this method.

This function is the same as the CPP method OGRGeometryCollection::addGeometry.

Parameters:

  | hGeom | existing geometry container.
  | hNewSubGeom | geometry to add to the container.

Returns:
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of existing geometry.

OGRErr OGR_G_AddGeometryDirectly | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hNewSubGeom |
| ) |  |  |

Add a geometry directly to an existing geometry container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. Ownership of the passed geometry is taken by the container rather than cloning as addGeometry() does.

This function is the same as the CPP method OGRGeometryCollection::addGeometryDirectly.

There is no SFCOM analog to this method.

Parameters:

  | hGeom | existing geometry.
  | hNewSubGeom | geometry to add to the existing geometry.

Returns:
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

void OGR_G_AddPoint | ( | OGRGeometryH | hGeom,
|  | double | dfX,
|  | double | dfY,
|  | double | dfZ |
| ) |  |  |

Add a point to a geometry (line string or point).

The vertex count of the line string is increased by one, and assigned from the passed location value.

Parameters:

  | hGeom | handle to the geometry to add a point to.
  | dfX | x coordinate of point to add.
  | dfY | y coordinate of point to add.
  | dfZ | z coordinate of point to add.

void OGR_G_AddPoint_2D | ( | OGRGeometryH | hGeom,
|  | double | dfX,
|  | double | dfY |
| ) |  |  |

Add a point to a geometry (line string or point).

The vertex count of the line string is increased by one, and assigned from the passed location value.

Parameters:

  | hGeom | handle to the geometry to add a point to.
  | dfX | x coordinate of point to add.
  | dfY | y coordinate of point to add.

void OGR_G_AssignSpatialReference | ( | OGRGeometryH | hGeom,
|  | OGRSpatialReferenceH | hSRS |
| ) |  |  |

Assign spatial reference to this object. Any existing spatial reference is replaced, but under no circumstances does this result in the object being reprojected. It is just changing the interpretation of the existing geometry. Note that assigning a spatial reference increments the reference count on the OGRSpatialReference, but does not copy it.

This is similar to the SFCOM IGeometry::put_SpatialReference() method.

This function is the same as the CPP method OGRGeometry::assignSpatialReference.

Parameters:

  | hGeom | handle on the geometry to apply the new spatial reference system.
  | hSRS | handle on the new spatial reference system to apply.

OGRGeometryH OGR_G_Clone | ( | OGRGeometryH | hGeom | ) |

Make a copy of this object.

This function relates to the SFCOM IGeometry::clone() method.

This function is the same as the CPP method OGRGeometry::clone().

Parameters:

  | hGeom | handle on the geometry to clone from.

Returns:
  an handle on the copy of the geometry with the spatial reference system as the original.

OGRErr OGR_G_CreateFromWkb | ( | unsigned char * | pabyData,
|  | OGRSpatialReferenceH | hSRS,
|  | OGRGeometryH * | phGeometry,
|  | int | nBytes |
| ) |  |  |

Create a geometry object of the appropriate type from it's well known binary representation.

Note that if nBytes is passed as zero, no checking can be done on whether the pabyData is sufficient. This can result in a crash if the input data is corrupt. This function returns no indication of the number of bytes from the data source actually used to represent the returned geometry object. Use OGR_G_WkbSize() on the returned geometry to establish the number of bytes it required in WKB format.

The OGRGeometryFactory::createFromWkb() CPP method is the same as this function.

Parameters:

  | pabyData | pointer to the input BLOB data.
  | hSRS | handle to the spatial reference to be assigned to the created geometry object. This may be NULL.
  | phGeometry | the newly created geometry object will be assigned to the indicated handle on return. This will be NULL in case of failure.
  | nBytes | the number of bytes of data available in pabyData, or -1 if it is not known, but assumed to be sufficient.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

OGRErr OGR_G_CreateFromWkt | ( | char ** | ppszData,
|  | OGRSpatialReferenceH | hSRS,
|  | OGRGeometryH * | phGeometry |
| ) |  |  |

Create a geometry object of the appropriate type from it's well known text representation.

The OGRGeometryFactory::createFromWkt CPP method is the same as this function.

Parameters:

  | ppszData | input zero terminated string containing well known text representation of the geometry to be created. The pointer is updated to point just beyond that last character consumed.
  | hSRS | handle to the spatial reference to be assigned to the created geometry object. This may be NULL.
  | phGeometry | the newly created geometry object will be assigned to the indicated handle on return. This will be NULL if the method fails.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

OGRGeometryH OGR_G_CreateGeometry | ( | OGRwkbGeometryType | eGeometryType | ) |

Create an empty geometry of desired type.

This is equivelent to allocating the desired geometry with new, but the allocation is guaranteed to take place in the context of the GDAL/OGR heap.

This function is the same as the CPP method OGRGeometryFactory::createGeometry.

Parameters:

  | eGeometryType | the type code of the geometry to be created.

Returns:
  handle to the newly create geometry or NULL on failure.

void OGR_G_DestroyGeometry | ( | OGRGeometryH | hGeom | ) |

Destroy geometry object.

Equivalent to invoking delete on a geometry, but it guaranteed to take place within the context of the GDAL/OGR heap.

This function is the same as the CPP method OGRGeometryFactory::destroyGeometry.

Parameters:

  | hGeom | handle to the geometry to delete.

void OGR_G_DumpReadable | ( | OGRGeometryH | hGeom,
|  | FILE * | fp,
|  | const char * | pszPrefix |
| ) |  |  |

Dump geometry in well known text format to indicated output file.

This method is the same as the CPP method OGRGeometry::dumpReadable.

Parameters:

  | hGeom | handle on the geometry to dump.
  | fp | the text file to write the geometry to.
  | pszPrefix | the prefix to put on each line of output.

void OGR_G_Empty | ( | OGRGeometryH | hGeom | ) |

Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This function relates to the SFCOM IGeometry::Empty() method.

This function is the same as the CPP method OGRGeometry::empty().

Parameters:

  | hGeom | handle on the geometry to empty.

int OGR_G_Equals | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hOther |
| ) |  |  |

Returns two if two geometries are equivalent.

This function is the same as the CPP method OGRGeometry::Equals() method.

Parameters:

  | hGeom | handle on the first geometry.
  | hOther | handle on the other geometry to test against.

Returns:
  TRUE if equivalent or FALSE otherwise.

OGRErr OGR_G_ExportToWkb | ( | OGRGeometryH | hGeom,
|  | OGRwkbByteOrder | eOrder,
|  | unsigned char * | pabyDstBuffer |
| ) |  |  |

Convert a geometry into well known binary format.

This function relates to the SFCOM IWks::ExportToWKB() method.

This function is the same as the CPP method OGRGeometry::exportToWkb().

Parameters:

  | hGeom | handle on the geometry to convert to a well know binary data from.
  | eOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyDstBuffer | a buffer into which the binary representation is written. This buffer must be at least OGR_G_WkbSize() byte in size.

Returns:
  Currently OGRERR_NONE is always returned.

OGRErr OGR_G_ExportToWkt | ( | OGRGeometryH | hGeom,
|  | char ** | ppszSrcText |
| ) |  |  |

Convert a geometry into well known text format.

This function relates to the SFCOM IWks::ExportToWKT() method.

This function is the same as the CPP method OGRGeometry::exportToWkt().

Parameters:

  | hGeom | handle on the geometry to convert to a text format from.
  | ppszSrcText | a text buffer is allocated by the program, and assigned to the passed pointer.

Returns:
  Currently OGRERR_NONE is always returned.

void OGR_G_FlattenTo2D | ( | OGRGeometryH | hGeom | ) |

Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0.

This function is the same as the CPP method OGRGeometry::flattenTo2D().

Parameters:

  | hGeom | handle on the geometry to convert.

double OGR_G_GetArea | ( | OGRGeometryH | hGeom | ) |

Compute geometry area.

Computes the area for an OGRLinearRing, OGRPolygon or OGRMultiPolygon. Undefined for all other geometry types (returns zero).

This function utilizes the C++ get_Area() methods such as OGRPolygon::get_Area().

Parameters:

  | hGeom | the geometry to operate on.

Returns:
  the area or 0.0 for unsupported geometry types.

int OGR_G_GetCoordinateDimension | ( | OGRGeometryH | hGeom | ) |

Get the dimension of the coordinates in this geometry.

This function corresponds to the SFCOM IGeometry::GetDimension() method.

This function is the same as the CPP method OGRGeometry::getCoordinateDimension().

Parameters:

  | hGeom | handle on the geometry to get the dimension of the coordinates from.

Returns:
  in practice this always returns 2 indicating that coordinates are specified within a two dimensional space.

int OGR_G_GetDimension | ( | OGRGeometryH | hGeom | ) |

Get the dimension of this geometry.

This function corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the geometry, but does not indicate the dimension of the underlying space (as indicated by OGR_G_GetCoordinateDimension() function).

This function is the same as the CPP method OGRGeometry::getDimension().

Parameters:

  | hGeom | handle on the geometry to get the dimension from.

Returns:
  0 for points, 1 for lines and 2 for surfaces.

void OGR_G_GetEnvelope | ( | OGRGeometryH | hGeom,
|  | OGREnvelope * | psEnvelope |
| ) |  |  |

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This function is the same as the CPP method OGRGeometry::getEnvelope().

Parameters:

  | hGeom | handle of the geometry to get envelope from.
  | psEnvelope | the structure in which to place the results.

int OGR_G_GetGeometryCount | ( | OGRGeometryH | hGeom | ) |

Fetch the number of elements in a geometry or number of geometries in container.

Parameters:

  | hGeom | single geometry or geometry container from which to get the number of elements.

Returns:
  the number of elements.

const char* OGR_G_GetGeometryName | ( | OGRGeometryH | hGeom | ) |

Fetch WKT name for geometry type.

There is no SFCOM analog to this function.

This function is the same as the CPP method OGRGeometry::getGeometryName().

Parameters:

  | hGeom | handle on the geometry to get name from.

Returns:
  name used for this geometry type in well known text format.

OGRGeometryH OGR_G_GetGeometryRef | ( | OGRGeometryH | hGeom,
|  | int | iSubGeom |
| ) |  |  |

Fetch geometry from a geometry container.

This function returns an handle to a geometry within the container. The returned geometry remains owned by the container, and should not be modified. The handle is only valid untill the next change to the geometry container. Use OGR_G_Clone() to make a copy.

This function relates to the SFCOM IGeometryCollection::get_Geometry() method.

This function is the same as the CPP method OGRGeometryCollection::getGeometryRef().

Parameters:

  | hGeom | handle to the geometry container from which to get a geometry from.
  | iSubGeom | the index of the geometry to fetch, between 0 and getNumGeometries() - 1.

Returns:
  handle to the requested geometry.

OGRwkbGeometryType OGR_G_GetGeometryType | ( | OGRGeometryH | hGeom | ) |

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This function is the same as the CPP method OGRGeometry::getGeometryType().

Parameters:

  | hGeom | handle on the geometry to get type from.

Returns:
  the geometry type code.

void OGR_G_GetPoint | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double * | pdfX,
|  | double * | pdfY,
|  | double * | pdfZ |
| ) |  |  |

Fetch a point in line string or a point geometry.

Parameters:

  | hGeom | handle to the geometry from which to get the coordinates.
  | i | the vertex to fetch, from 0 to getNumPoints()-1, zero for a point.
  | pdfX | value of x coordinate.
  | pdfY | value of y coordinate.
  | pdfZ | value of z coordinate.

int OGR_G_GetPointCount | ( | OGRGeometryH | hGeom | ) |

Fetch number of points from a geometry.

Parameters:

  | hGeom | handle to the geometry from which to get the number of points.

Returns:
  the number of points.

OGRSpatialReferenceH OGR_G_GetSpatialReference | ( | OGRGeometryH | hGeom | ) |

Returns spatial reference system for geometry.

This function relates to the SFCOM IGeometry::get_SpatialReference() method.

This function is the same as the CPP method OGRGeometry::getSpatialReference().

Parameters:

  | hGeom | handle on the geometry to get spatial reference from.

Returns:
  a reference to the spatial reference geometry.

double OGR_G_GetX | ( | OGRGeometryH | hGeom,
|  | int | i |
| ) |  |  |

Fetch the x coordinate of a point from a geometry.

Parameters:

  | hGeom | handle to the geometry from which to get the x coordinate.
  | i | point to get the x coordinate.

Returns:
  the X coordinate of this point.

double OGR_G_GetY | ( | OGRGeometryH | hGeom,
|  | int | i |
| ) |  |  |

Fetch the x coordinate of a point from a geometry.

Parameters:

  | hGeom | handle to the geometry from which to get the y coordinate.
  | i | point to get the Y coordinate.

Returns:
  the Y coordinate of this point.

double OGR_G_GetZ | ( | OGRGeometryH | hGeom,
|  | int | i |
| ) |  |  |

Fetch the z coordinate of a point from a geometry.

Parameters:

  | hGeom | handle to the geometry from which to get the Z coordinate.
  | i | point to get the Z coordinate.

Returns:
  the Z coordinate of this point.

OGRErr OGR_G_ImportFromWkb | ( | OGRGeometryH | hGeom,
|  | unsigned char * | pabyData,
|  | int | nSize |
| ) |  |  |

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type.

This function relates to the SFCOM IWks::ImportFromWKB() method.

This function is the same as the CPP method OGRGeometry::importFromWkb().

Parameters:

  | hGeom | handle on the geometry to assign the well know binary data to.
  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

OGRErr OGR_G_ImportFromWkt | ( | OGRGeometryH | hGeom,
|  | char ** | ppszSrcText |
| ) |  |  |

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type.

This function relates to the SFCOM IWks::ImportFromWKT() method.

This function is the same as the CPP method OGRGeometry::importFromWkt().

Parameters:

  | hGeom | handle on the geometry to assign well know text data to.
  | ppszSrcText | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

int OGR_G_Intersects | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hOtherGeom |
| ) |  |  |

Do these features intersect?

Currently this is not implemented in a rigerous fashion, and generally just tests whether the envelopes of the two features intersect. Eventually this will be made rigerous.

This function is the same as the CPP method OGRGeometry::Intersects.

Parameters:

  | hGeom | handle on the first geometry.
  | hOtherGeom | handle on the other geometry to test against.

Returns:
  TRUE if the geometries intersect, otherwise FALSE.

int OGR_G_IsEmpty | ( | OGRGeometryH | hGeom | ) |

Test if the geometry is empty

This method is the same as the CPP method OGRGeometry::IsEmpty().

Returns:
  TRUE if the geometry has no points, otherwise FALSE.

int OGR_G_IsSimple | ( | OGRGeometryH | hGeom | ) |

Returns TRUE if the geometry is simple.

Returns TRUE if the geometry has no anomalous geometric points, such as self intersection or self tangency. The description of each instantiable geometric class will include the specific conditions that cause an instance of that class to be classified as not simple.

This method relates to the SFCOM IGeometry::IsSimple() method.

NOTE: This method is hardcoded to return TRUE at this time.

Returns:
  TRUE if object is simple, otherwise FALSE.

OGRErr OGR_G_RemoveGeometry | ( | OGRGeometryH | hGeom,
|  | int | iGeom,
|  | int | bDelete |
| ) |  |  |

Remove a geometry from an exiting geometry container.

Removing a geometry will cause the geometry count to drop by one, and all "higher" geometries will shuffle down one in index.

There is no SFCOM analog to this method.

This function is the same as the CPP method OGRGeometryCollection::removeGeometry().

Parameters:

  | hGeom | the existing geometry to delete from.
  | iGeom | the index of the geometry to delete. A value of -1 is a special flag meaning that all geometries should be removed.
  | bDelete | if TRUE the geometry will be destroyed, otherwise it will not. The default is TRUE as the existing geometry is considered to own the geometries in it.

Returns:
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is out of range.

void OGR_G_Segmentize | ( | OGRGeometryH | hGeom,
|  | double | dfMaxLength |
| ) |  |  |

Modify the geometry such it has no segment longer then the given distance. Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the CPP method OGRGeometry::segmentize().

Parameters:

  | hGeom | handle on the geometry to segmentize
  | dfMaxLength | the maximum distance between 2 points after segmentization

void OGR_G_SetPoint | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double | dfX,
|  | double | dfY,
|  | double | dfZ |
| ) |  |  |

Set the location of a vertex in a point or linestring geometry.

If iPoint is larger than the number of existing points in the linestring, the point count will be increased to accomodate the request.

Parameters:

  | hGeom | handle to the geometry to add a vertex to.
  | i | the index of the vertex to assign (zero based) or zero for a point.
  | dfX | input X coordinate to assign.
  | dfY | input Y coordinate to assign.
  | dfZ | input Z coordinate to assign (defaults to zero).

void OGR_G_SetPoint_2D | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double | dfX,
|  | double | dfY |
| ) |  |  |

Set the location of a vertex in a point or linestring geometry.

If iPoint is larger than the number of existing points in the linestring, the point count will be increased to accomodate the request.

Parameters:

  | hGeom | handle to the geometry to add a vertex to.
  | i | the index of the vertex to assign (zero based) or zero for a point.
  | dfX | input X coordinate to assign.
  | dfY | input Y coordinate to assign.

OGRErr OGR_G_Transform | ( | OGRGeometryH | hGeom,
|  | OGRCoordinateTransformationH | hTransform |
| ) |  |  |

Apply arbitrary coordinate transformation to geometry.

This function will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this function does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This function is the same as the CPP method OGRGeometry::transform.

Parameters:

  | hGeom | handle on the geometry to apply the transform to.
  | hTransform | handle on the transformation to apply.

Returns:
  OGRERR_NONE on success or an error code.

OGRErr OGR_G_TransformTo | ( | OGRGeometryH | hGeom,
|  | OGRSpatialReferenceH | hSRS |
| ) |  |  |

Transform geometry to new spatial reference system.

This function will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

This function will only work if the geometry already has an assigned spatial reference system, and if it is transformable to the target coordinate system.

Because this function requires internal creation and initialization of an OGRCoordinateTransformation object it is significantly more expensive to use this function to transform many geometries than it is to create the OGRCoordinateTransformation in advance, and call transform() with that transformation. This function exists primarily for convenience when only transforming a single geometry.

This function is the same as the CPP method OGRGeometry::transformTo.

Parameters:

  | hGeom | handle on the geometry to apply the transform to.
  | hSRS | handle on the spatial reference system to apply.

Returns:
  OGRERR_NONE on success, or an error code.

int OGR_G_WkbSize | ( | OGRGeometryH | hGeom | ) |

Returns size of related binary representation.

This function returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This function relates to the SFCOM IWks::WkbSize() method.

This function is the same as the CPP method OGRGeometry::WkbSize().

Parameters:

  | hGeom | handle on the geometry to get the binary size from.

Returns:
  size of binary representation in bytes.

const char* OGR_GetFieldTypeName | ( | OGRFieldType | eType | ) |

Fetch human readable name for a field type.

This function is the same as the CPP method OGRFieldDefn::GetFieldTypeName().

Parameters:

  | eType | the field type to get name for.

Returns:
  the name.

OGRErr OGR_L_CommitTransaction | ( | OGRLayerH | hLayer | ) |

For datasources which support transactions, CommitTransaction commits a transaction. If no transaction is active, or the commit fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_NONE.

This function is the same as the C++ method OGRLayer::CommitTransaction().

Parameters:

  | hLayer | handle to the layer

Returns:
  OGRERR_NONE on success.

OGRErr OGR_L_CreateFeature | ( | OGRLayerH | hLayer,
|  | OGRFeatureH | hFeat |
| ) |  |  |

Create and write a new feature within a layer.

The passed feature is written to the layer as a new feature, rather than overwriting an existing one. If the feature has a feature id other than OGRNullFID, then the native implementation may use that as the feature id of the new feature, but not necessarily. Upon successful return the passed feature will have been updated with the new feature id.

This function is the same as the C++ method OGRLayer::CreateFeature().

Parameters:

  | hLayer | handle to the layer to write the feature to.
  | hFeat | the handle of the feature to write to disk.

Returns:
  OGRERR_NONE on success.

OGRErr OGR_L_CreateField | ( | OGRLayerH | hLayer,
|  | OGRFieldDefnH | hField,
|  | int | bApproxOK |
| ) |  |  |

Create a new field on a layer. You must use this to create new fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the new field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function is the same as the C++ method OGRLayer::CreateField().

Parameters:

  | hLayer | handle to the layer to write the field definition.
  | hField | handle of the field definition to write to disk.
  | bApproxOK | If TRUE, the field may be created in a slightly different form depending on the limitations of the format driver.

Returns:
  OGRERR_NONE on success.

OGRErr OGR_L_DeleteFeature | ( | OGRLayerH | hLayer,
|  | long | nFID |
| ) |  |  |

Delete feature from layer.

The feature with the indicated feature id is deleted from the layer if supported by the driver. Most drivers do not support feature deletion, and will return OGRERR_UNSUPPORTED_OPERATION. The OGR_L_TestCapability() function may be called with OLCDeleteFeature to check if the driver supports feature deletion.

This method is the same as the C++ method OGRLayer::DeleteFeature().

Parameters:

  | hLayer | handle to the layer
  | nFID | the feature id to be deleted from the layer

Returns:
  OGRERR_NONE on success.

OGRErr OGR_L_GetExtent | ( | OGRLayerH | hLayer,
|  | OGREnvelope * | psExtent,
|  | int | bForce |
| ) |  |  |

Fetch the extent of this layer.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call OGR_L_GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

This function is the same as the C++ method OGRLayer::GetExtent().

Parameters:

  | hLayer | handle to the layer from which to get extent.
  | psExtent | the structure in which the extent value will be returned.
  | bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns:
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

OGRFeatureH OGR_L_GetFeature | ( | OGRLayerH | hLayer,
|  | long | nFeatureId |
| ) |  |  |

Fetch a feature by it's identifier.

This function will attempt to read the identified feature. The nFID value cannot be OGRNullFID. Success or failure of this operation is unaffected by the spatial or attribute filters.

If this function returns a non-NULL feature, it is guaranteed that it's feature id (OGR_F_GetFID()) will be the same as nFID.

Use OGR_L_TestCapability(OLCRandomRead) to establish if this layer supports efficient random access reading via OGR_L_GetFeature(); however, the call should always work if the feature exists as a fallback implementation just scans all the features in the layer looking for the desired feature.

Sequential reads are generally considered interrupted by a OGR_L_GetFeature() call.

This function is the same as the C++ method OGRLayer::GetFeature( ).

Parameters:

  | hLayer | handle to the layer that owned the feature.
  | nFeatureId | the feature id of the feature to read.

Returns:
  an handle to a feature now owned by the caller, or NULL on failure.

int OGR_L_GetFeatureCount | ( | OGRLayerH | hLayer,
|  | int | bForce |
| ) |  |  |

Fetch the feature count in this layer.

Returns the number of features in the layer. For dynamic databases the count may not be exact. If bForce is FALSE, and it would be expensive to establish the feature count a value of -1 may be returned indicating that the count isn't know. If bForce is TRUE some implementations will actually scan the entire layer once to count objects.

The returned count takes the spatial filter into account.

This function is the same as the CPP OGRLayer::GetFeatureCount().

Parameters:

  | hLayer | handle to the layer that owned the features.
  | bForce | Flag indicating whether the count should be computed even if it is expensive.

Returns:
  feature count, -1 if count not known.

OGRFeatureDefnH OGR_L_GetLayerDefn | ( | OGRLayerH | hLayer | ) |

Fetch the schema information for this layer.

The returned handle to the OGRFeatureDefn is owned by the OGRLayer, and should not be modified or freed by the application. It encapsulates the attribute schema of the features of the layer.

This function is the same as the C++ method OGRLayer::GetLayerDefn().

Parameters:

  | hLayer | handle to the layer to get the schema information.

Returns:
  an handle to the feature definition.

OGRFeatureH OGR_L_GetNextFeature | ( | OGRLayerH | hLayer | ) |

Fetch the next available feature from this layer. The returned feature becomes the responsiblity of the caller to delete. It is critical that all features associated with an OGRLayer (more specifically an OGRFeatureDefn) be deleted before that layer/datasource is deleted.

Only features matching the current spatial filter (set with SetSpatialFilter()) will be returned.

This function implements sequential access to the features of a layer. The OGR_L_ResetReading() function can be used to start at the beginning again. Random reading, writing and spatial filtering will be added to the OGRLayer in the future.

This function is the same as the C++ method OGRLayer::GetNextFeature().

Parameters:

  | hLayer | handle to the layer from which feature are read.

Returns:
  an handle to a feature, or NULL if no more features are available.

OGRGeometryH OGR_L_GetSpatialFilter | ( | OGRLayerH | hLayer | ) |

This function returns the current spatial filter for this layer.

The returned pointer is to an internally owned object, and should not be altered or deleted by the caller.

This function is the same as the C++ method OGRLayer::GetSpatialFilter().

Parameters:

  | hLayer | handle to the layer to get the spatial filter from.

Returns:
  an handle to the spatial filter geometry.

OGRSpatialReferenceH OGR_L_GetSpatialRef | ( | OGRLayerH | hLayer | ) |

Fetch the spatial reference system for this layer.

The returned object is owned by the OGRLayer and should not be modified or freed by the application.

This function is the same as the C++ method OGRLayer::GetSpatialRef().

Parameters:

  | hLayer | handle to the layer to get the spatial reference from.

Returns:
  spatial reference, or NULL if there isn't one.

void OGR_L_ResetReading | ( | OGRLayerH | hLayer | ) |

Reset feature reading to start on the first feature. This affects GetNextFeature().

This function is the same as the C++ method OGRLayer::ResetReading().

Parameters:

  | hLayer | handle to the layer on which features are read.

OGRErr OGR_L_RollbackTransaction | ( | OGRLayerH | hLayer | ) |

For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction. If no transaction is active, or the rollback fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_NONE.

This function is the same as the C++ method OGRLayer::RollbackTransaction().

Parameters:

  | hLayer | handle to the layer

Returns:
  OGRERR_NONE on success.

OGRErr OGR_L_SetAttributeFilter | ( | OGRLayerH | hLayer,
|  | const char * | pszQuery |
| ) |  |  |

Set a new attribute query.

This function sets the attribute query string to be used when fetching features via the OGR_L_GetNextFeature() function. Only features for which the query evaluates as true will be returned.

The query string should be in the format of an SQL WHERE clause. For instance "population > 1000000 and population < 5000000" where population is an attribute in the layer. The query format is a restricted form of SQL WHERE clause as defined "eq_format=restricted_where" about half way through this document:

http://ogdi.sourceforge.net/prop/6.2.CapabilitiesMetadata.html

Note that installing a query string will generally result in resetting the current reading position (ala OGR_L_ResetReading()).

This function is the same as the C++ method OGRLayer::SetAttributeFilter().

Parameters:

  | hLayer | handle to the layer on which attribute query will be executed.
  | pszQuery | query in restricted SQL WHERE format, or NULL to clear the current query.

Returns:
  OGRERR_NONE if successfully installed, or an error code if the query expression is in error, or some other failure occurs.

OGRErr OGR_L_SetFeature | ( | OGRLayerH | hLayer,
|  | OGRFeatureH | hFeat |
| ) |  |  |

Rewrite an existing feature.

This function will write a feature to the layer, based on the feature id within the OGRFeature.

Use OGR_L_TestCapability(OLCRandomWrite) to establish if this layer supports random access writing via OGR_L_SetFeature().

This function is the same as the C++ method OGRLayer::SetFeature().

Parameters:

  | hLayer | handle to the layer to write the feature.
  | hFeat | the feature to write.

Returns:
  OGRERR_NONE if the operation works, otherwise an appropriate error code.

void OGR_L_SetSpatialFilter | ( | OGRLayerH | hLayer,
|  | OGRGeometryH | hGeom |
| ) |  |  |

Set a new spatial filter.

This function set the geometry to be used as a spatial filter when fetching features via the OGR_L_GetNextFeature() function. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGR_G_GetEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This function makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the layer (as returned by OGR_L_GetSpatialRef()). In the future this may be generalized.

This function is the same as the C++ method OGRLayer::SetSpatialFilter.

Parameters:

  | hLayer | handle to the layer on which to set the spatial filter.
  | hGeom | handle to the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

void OGR_L_SetSpatialFilterRect | ( | OGRLayerH | hLayer,
|  | double | dfMinX,
|  | double | dfMinY,
|  | double | dfMaxX,
|  | double | dfMaxY |
| ) |  |  |

Set a new rectangular spatial filter.

This method set rectangle to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the given rectangle will be returned.

The x/y values should be in the same coordinate system as the layer as a whole (as returned by OGRLayer::GetSpatialRef()). Internally this method is normally implemented as creating a 5 vertex closed rectangular polygon and passing it to OGRLayer::SetSpatialFilter(). It exists as a convenience.

The only way to clear a spatial filter set with this method is to call OGRLayer::SetSpatialFilter(NULL).

This method is the same as the C++ method OGRLayer::SetSpatialFilterRect().

Parameters:

  | hLayer | handle to the layer on which to set the spatial filter.
  | dfMinX | the minimum X coordinate for the rectangular region.
  | dfMinY | the minimum Y coordinate for the rectangular region.
  | dfMaxX | the maximum X coordinate for the rectangular region.
  | dfMaxY | the maximum Y coordinate for the rectangular region.

OGRErr OGR_L_StartTransaction | ( | OGRLayerH | hLayer | ) |

For datasources which support transactions, StartTransaction creates a transaction. If starting the transaction fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_NONE.

This function is the same as the C++ method OGRLayer::StartTransaction().

Parameters:

  | hLayer | handle to the layer

Returns:
  OGRERR_NONE on success.

int OGR_L_TestCapability | ( | OGRLayerH | hLayer,
|  | const char * | pszCap |
| ) |  |  |

Test if this layer supported the named capability.

The capability codes that can be tested are represented as strings, but #defined constants exists to ensure correct spelling. Specific layer types may implement class specific capabilities, but this can't generally be discovered by the caller.

- OLCRandomRead / "RandomRead": TRUE if the OGR_L_GetFeature() function works for this layer.

- OLCSequentialWrite / "SequentialWrite": TRUE if the OGR_L_CreateFeature() function works for this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCRandomWrite / "RandomWrite": TRUE if the OGR_L_SetFeature() function is operational on this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCFastSpatialFilter / "FastSpatialFilter": TRUE if this layer implements spatial filtering efficiently. Layers that effectively read all features, and test them with the OGRFeature intersection methods should return FALSE. This can be used as a clue by the application whether it should build and maintain it's own spatial index for features in this layer.

- OLCFastFeatureCount / "FastFeatureCount": TRUE if this layer can return a feature count (via OGR_L_GetFeatureCount()) efficiently ... ie. without counting the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastGetExtent / "FastGetExtent": TRUE if this layer can return its data extent (via OGR_L_GetExtent()) efficiently ... ie. without scanning all the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

This function is the same as the C++ method OGRLayer::TestCapability().

Parameters:

  | hLayer | handle to the layer to get the capability from.
  | pszCap | the name of the capability to test.

Returns:
  TRUE if the layer has the requested capability, or FALSE otherwise. OGRLayers will return FALSE for any unrecognised capabilities.

int OGR_SM_AddPart | ( | OGRStyleMgrH | hSM,
|  | OGRStyleToolH | hST |
| ) |  |  |

Add a part (style tool) to the current style.

This function is the same as the C++ method OGRStyleMgr::AddPart().

Parameters:

  | hSM | handle to the style manager.
  | hST | the style tool defining the part to add.

Returns:
  TRUE on success, FALSE on errors.

OGRStyleMgrH OGR_SM_Create | ( | void * | hStyleTable | ) |

OGRStyleMgr factory.

This function is the same as the C++ method OGRStyleMgr::OGRStyleMgr().

Parameters:

  | hStyleTable | (currently unused, reserved for future use), pointer to OGRStyleTable. Pass NULL for now.

Returns:
  an handle to the new style manager object.

void OGR_SM_Destroy | ( | OGRStyleMgrH | hSM | ) |

Destroy Style Manager

Parameters:

  | hSM | handle to the style manager to destroy.

OGRStyleToolH OGR_SM_GetPart | ( | OGRStyleMgrH | hSM,
|  | int | nPartId,
|  | const char * | pszStyleString |
| ) |  |  |

Fetch a part (style tool) from the current style.

This function is the same as the C++ method OGRStyleMgr::GetPart().

Parameters:

  | hSM | handle to the style manager.
  | nPartId | the part number (0-based index)
  | pszStyleString | (optional) the style string on which to operate. If NULL then the current style string stored in the style manager is used.

Returns:
  OGRStyleToolH of the requested part (style tools) or NULL on error.

int OGR_SM_GetPartCount | ( | OGRStyleMgrH | hSM,
|  | const char * | pszStyleString |
| ) |  |  |

Add a part (style tool) to the current style.

This function is the same as the C++ method OGRStyleMgr::GetPartCount().

Parameters:

  | hSM | handle to the style manager.
  | pszStyleString | (optional) the style string on which to operate. If NULL then the current style string stored in the style manager is used.

Returns:
  the number of parts (style tools) in the style.

const char* OGR_SM_InitFromFeature | ( | OGRStyleMgrH | hSM,
|  | OGRFeatureH | hFeat |
| ) |  |  |

Initialize style manager from the style string of a feature.

This function is the same as the C++ method OGRStyleMgr::InitFromFeature().

Parameters:

  | hSM | handle to the style manager.
  | hFeature | handle to the new feature from which to read the style.

Returns:
  a reference to the style string read from the feature, or NULL in case of error..

int OGR_SM_InitStyleString | ( | OGRStyleMgrH | hSM,
|  | const char * | pszStyleString |
| ) |  |  |

Initialize style manager from the style string.

This function is the same as the C++ method OGRStyleMgr::InitStyleString().

Parameters:

  | hSM | handle to the style manager.
  | pszStyleString | the style string to use (can be NULL).

Returns:
  TRUE on success, FALSE on errors.

OGRStyleToolH OGR_ST_Create | ( | OGRSTClassId | eClassId | ) |

OGRStyleTool factory.

This function is a constructor for OGRStyleTool derived classes.

Parameters:

  | eClassId | subclass of style tool to create. One of OGRSTCPen (1), OGRSTCBrush (2), OGRSTCSymbol (3) or OGRSTCLabel (4).

Returns:
  an handle to the new style tool object or NULL if the creation failed.

void OGR_ST_Destroy | ( | OGRStyleToolH | hST | ) |

Destroy Style Tool

Parameters:

  | hST | handle to the style tool to destroy.

double OGR_ST_GetParamDbl | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int * | bValueIsNull |
| ) |  |  |

Get Style Tool parameter value as a double

Maps to the OGRStyleTool subclasses' GetParamDbl() methods.

Parameters:

  | hST | handle to the style tool.
  | eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  | bValueIsNull | pointer to an integer that will be set to TRUE or FALSE to indicate whether the parameter value is NULL.

Returns:
  the parameter value as double and sets bValueIsNull.

int OGR_ST_GetParamNum | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int * | bValueIsNull |
| ) |  |  |

Get Style Tool parameter value as an integer

Maps to the OGRStyleTool subclasses' GetParamNum() methods.

Parameters:

  | hST | handle to the style tool.
  | eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  | bValueIsNull | pointer to an integer that will be set to TRUE or FALSE to indicate whether the parameter value is NULL.

Returns:
  the parameter value as integer and sets bValueIsNull.

const char* OGR_ST_GetParamStr | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int * | bValueIsNull |
| ) |  |  |

Get Style Tool parameter value as string

Maps to the OGRStyleTool subclasses' GetParamStr() methods.

Parameters:

  | hST | handle to the style tool.
  | eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  | bValueIsNull | pointer to an integer that will be set to TRUE or FALSE to indicate whether the parameter value is NULL.

Returns:
  the parameter value as string and sets bValueIsNull.

int OGR_ST_GetRGBFromString | ( | OGRStyleToolH | hST,
|  | const char * | pszColor,
|  | int * | pnRed,
|  | int * | pnGreen,
|  | int * | pnBlue,
|  | int * | pnAlpha |
| ) |  |  |

Return the r,g,b,a components of a color encoded in RRGGBB[AA] format

Maps to OGRStyleTool::GetRGBFromString().

Parameters:

  | hST | handle to the style tool.
  | pszColor | the color to parse
  | pnRed | pointer to an int in which the red value will be returned
  | pnGreen | pointer to an int in which the green value will be returned
  | pnBlue | pointer to an int in which the blue value will be returned
  | pnAlpha | pointer to an int in which the (optional) alpha value will be returned

Returns:
  TRUE if the color could be succesfully parsed, or FALSE in case of errors.

const char* OGR_ST_GetStyleString | ( | OGRStyleToolH | hST | ) |

Get the style string for this Style Tool

Maps to the OGRStyleTool subclasses' GetStyleString() methods.

Parameters:

  | hST | handle to the style tool.

Returns:
  the style string for this style tool or "" if the hST is invalid.

OGRSTClassId OGR_ST_GetType | ( | OGRStyleToolH | hST | ) |

Determine type of Style Tool

Parameters:

  | hST | handle to the style tool.

Returns:
  the style tool type, one of OGRSTCPen (1), OGRSTCBrush (2), OGRSTCSymbol (3) or OGRSTCLabel (4). Returns OGRSTCNone (0) if the OGRStyleToolH is invalid.

OGRSTUnitId OGR_ST_GetUnit | ( | OGRStyleToolH | hST | ) |

Get Style Tool units

Parameters:

  | hST | handle to the style tool.

Returns:
  the style tool units.

void OGR_ST_SetParamNum | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int | nValue |
| ) |  |  |

Set Style Tool parameter value from an integer

Maps to the OGRStyleTool subclasses' SetParamNum() methods.

Parameters:

  | hST | handle to the style tool.
  | eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  | nValue | the new parameter value

void OGR_ST_SetParamStr | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | const char * | pszValue |
| ) |  |  |

Set Style Tool parameter value from a string

Maps to the OGRStyleTool subclasses' SetParamStr() methods.

Parameters:

  | hST | handle to the style tool.
  | eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  | pszValue | the new parameter value

void OGR_ST_SetUnit | ( | OGRStyleToolH | hST,
|  | OGRSTUnitId | eUnit,
|  | double | dfGroundPaperScale |
| ) |  |  |

Set Style Tool units

This function is the same as OGRStyleTool::SetUnit()

Parameters:

  | hST | handle to the style tool.
  | eUnit | the new unit.
  | dfGroundPaperScale | ground to paper scale factor.

OGRGeometryH OGRBuildPolygonFromEdges | ( | OGRGeometryH | hLines,
|  | int | bBestEffort,
|  | int | bAutoClose,
|  | double | dfTolerance,
|  | OGRErr * | peErr |
| ) |  |  |

Build a ring from a bunch of arcs.

Parameters:

  | hLines | handle to an OGRGeometryCollection (or OGRMultiLineString) containing the line string geometries to be built into rings.
  | bBestEffort | not yet implemented???.
  | bAutoClose | indicates if the ring should be close when first and last points of the ring are the same.
  | dfTolerance | tolerance into which two arcs are considered close enough to be joined.
  | peErr | OGRERR_NONE on success, or OGRERR_FAILURE on failure.

Returns:
  an handle to the new geometry, a polygon.

void OGRCleanupAll | ( | void |  | ) |

Cleanup all OGR related resources.

This function will destroy the OGRSFDriverRegistrar along with all registered drivers, and then cleanup long lived OSR (OGRSpatialReference) and CPL resources. This may be called in an application when OGR services are no longer needed. It is not normally required, but by freeing all dynamically allocated memory it can make memory leak testing easier.

In addition to destroying the OGRDriverRegistrar, this function also calls:

- OSRCleanup()
- CPLFinderClean()
- VSICleanupFileManager()
- CPLFreeConfig()
- CPLCleanupTLS()

OGRSFDriverH OGRGetDriver | ( | int | iDriver | ) |

Fetch the indicated driver.

This function is the same as the C++ method OGRSFDriverRegistrar::GetDriver().

Parameters:

  | iDriver | the driver index, from 0 to GetDriverCount()-1.

Returns:
  handle to the driver, or NULL if iDriver is out of range.

int OGRGetDriverCount | ( | void |  | ) |

Fetch the number of registered drivers.

This function is the same as the C++ method OGRSFDriverRegistrar::GetDriverCount().

Returns:
  the drivers count.

OGRDataSourceH OGROpen | ( | const char * | pszName,
|  | int | bUpdate,
|  | OGRSFDriverH * | pahDriverList |
| ) |  |  |

Open a file / data source with one of the registered drivers.

This function loops through all the drivers registered with the driver manager trying each until one succeeds with the given data source. This function is static. Applications don't normally need to use any other OGRSFDriverRegistrar function, not do they normally need to have a pointer to an OGRSFDriverRegistrar instance.

If this function fails, CPLGetLastErrorMsg() can be used to check if there is an error message explaining why.

This function is the same as the C++ method OGRSFDriverRegistrar::Open().

Parameters:

  | pszName | the name of the file, or data source to open.
  | bUpdate | FALSE for read-only access (the default) or TRUE for read-write access.
  | pahDriverList | if non-NULL, this argument will be updated with a pointer to the driver which was used to open the data source.

Returns:
  NULL on error or if the pass name is not supported by this driver, otherwise an handle to an OGRDataSource. This OGRDataSource should be closed by deleting the object when it is no longer needed.

Example:

        OGRDataSourceH	hDS;
        OGRSFDriverH        *pahDriver;

        hDS = OGROpen( "polygon.shp", 0, pahDriver );
        if( hDS == NULL )
        {
            return;
        }

        ... use the data source ...

        OGRReleaseDataSource( hDS );

int OGRRegisterAll | ( | void |  | ) |

Register all drivers.

void OGRRegisterDriver | ( | OGRSFDriverH | hDriver | ) |

Add a driver to the list of registered drivers.

If the passed driver is already registered (based on handle comparison) then the driver isn't registered. New drivers are added at the end of the list of registered drivers.

This function is the same as the C++ method OGRSFDriverRegistrar::RegisterDriver().

Parameters:

  | hDriver | handle to the driver to add.

Generated for GDAL by 1.5.1.